// OptiX_Test.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

/*
* Copyright (c) 2008 - 2009 NVIDIA Corporation.  All rights reserved.
*
* NVIDIA Corporation and its licensors retain all intellectual property and proprietary
* rights in and to this software, related documentation and any modifications thereto.
* Any use, reproduction, disclosure or distribution of this software and related
* documentation without an express license agreement from NVIDIA Corporation is strictly
* prohibited.
*
* TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED *AS IS*
* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED,
* INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
* PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS BE LIABLE FOR ANY
* SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES WHATSOEVER (INCLUDING, WITHOUT
* LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF
* BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS) ARISING OUT OF THE USE OF OR
* INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS BEEN ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGES
*/

#include <optix.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sutil.h>

int _tmain(int argc, _TCHAR* argv[])
{
	// RTAPI̎vȃIuWFNg
	RTcontext context;
	RTprogram ray_gen_program;
	RTbuffer  buffer;

	// p[^
	RTvariable result_buffer;
	RTvariable draw_color;

	// pX
	char path_to_ptx[512];
	// o͉摜
	char outfile[512] = "test.ppm";

	// 摜̕ƍ
	unsigned int width  = 512u;
	unsigned int height = 384u;
	int i;
	// glutgp
	int use_glut = 1;

	// ʂɃ_O鎞̓RgO
	// outfile[0] = '\0';

	// glut̏
	RT_CHECK_ERROR_NO_CONTEXT( sutilInitGlut( &argc, argv ) );

	// IuWFNg̍쐬ƏԂ̐ݒ
	RT_CHECK_ERROR( rtContextCreate( &context ) );
	RT_CHECK_ERROR( rtContextSetRayTypeCount( context, 1 ) );
	RT_CHECK_ERROR( rtContextSetEntryPointCount( context, 1 ) );

	// o͂邽߂̃obt@̍쐬
	RT_CHECK_ERROR( rtBufferCreate( context, RT_BUFFER_OUTPUT, &buffer ) );
	// tH[}bgfloat4^
	RT_CHECK_ERROR( rtBufferSetFormat( buffer, RT_FORMAT_FLOAT4 ) );
	// TCYwidth~height
	RT_CHECK_ERROR( rtBufferSetSize2D( buffer, width, height ) );
	// ReLXgresult_bufferƂresult_buffer֘AtH
	RT_CHECK_ERROR( rtContextDeclareVariable( context, "result_buffer", &result_buffer ) );
	RT_CHECK_ERROR( rtVariableSetObject( result_buffer, buffer ) );

	// ptxƂt@C炵
	sprintf( path_to_ptx, "%s/%s", sutilSamplesPtxDir(), "sample1_generated_draw_color.cu.ptx" );
	// PTXt@CvO쐬H
	RT_CHECK_ERROR( rtProgramCreateFromPTXFile( context, path_to_ptx, "draw_solid_color", &ray_gen_program ) );
	// vOdraw_colorƂdraw_color֘AtĒlݒH
	RT_CHECK_ERROR( rtProgramDeclareVariable( ray_gen_program, "draw_color", &draw_color ) );
	RT_CHECK_ERROR( rtVariableSet3f( draw_color, 1.0f, 0.0f, 0.0f ) );
	// ReLXgɃC𐶐vOݒ
	RT_CHECK_ERROR( rtContextSetRayGenerationProgram( context, 0, ray_gen_program ) );

	// s
	// ReLXgmF^LɂH
	RT_CHECK_ERROR( rtContextValidate( context ) );
	// ReLXgRpC
	RT_CHECK_ERROR( rtContextCompile( context ) );
	// ReLXgsi2D?j
	RT_CHECK_ERROR( rtContextLaunch2D( context, 0 /* entry point */, width, height ) );

	//@摜̕\
	if( strlen( outfile ) == 0 ) 
	{
		// o̓t@Cݒ肳ĂȂꍇ͉ʂɌʂ\
		RT_CHECK_ERROR( sutilDisplayBufferInGlutWindow( argv[0], buffer ) );
	}
	else
	{
		// ݒ肳ĂꍇPPMt@CƂďo͂
		RT_CHECK_ERROR( sutilDisplayFilePPM( outfile, buffer ) );
	}

	// I
	// obt@̍폜
	RT_CHECK_ERROR( rtBufferDestroy( buffer ) );
	// vO̍폜
	RT_CHECK_ERROR( rtProgramDestroy( ray_gen_program ) );
	// ReLXg̍폜
	RT_CHECK_ERROR( rtContextDestroy( context ) );

	return( 0 );
}
